---
title: box-sizing
slug: Web/CSS/box-sizing
tags:
  - Boxes
  - CSS
  - CSS Box Model
  - CSS Property
  - Reference
  - border-box
  - box model
  - box-sizing
  - content-box
  - height
  - 'recipe:css-property'
  - size
  - width
---
<p>{{CSSRef}}</p>

<p><span class="seoSummary">The <strong><code>box-sizing</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets how the total width and height of an element is calculated.</span></p>

<div>{{EmbedInteractiveExample("pages/css/box-sizing.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>By default in the <a href="/en-US/docs/Web/CSS/CSS_Box_Model/Introduction_to_the_CSS_box_model">CSS box model</a>, the <code>width</code> and <code>height</code> you assign to an element is applied only to the element's content box. If the element has any border or padding, this is then added to the <code>width</code> and <code>height</code> to arrive at the size of the box that's rendered on the screen. This means that when you set <code>width</code> and <code>height</code>, you have to adjust the value you give to allow for any border or padding that may be added. For example, if you have four boxes with <code>width: 25%;</code>, if any has left or right padding or a left or right border, they will not by default fit on one line within the constraints of the parent container.</p>

<p>The <code>box-sizing</code> property can be used to adjust this behavior:</p>

<ul>
 <li><code>content-box</code> gives you the default CSS box-sizing behavior. If you set an element's width to 100 pixels, then the element's content box will be 100 pixels wide, and the width of any border or padding will be added to the final rendered width, making the element wider than 100px.</li>
 <li><code>border-box</code> tells the browser to account for any border and padding in the values you specify for an element's width and height. If you set an element's width to 100 pixels, that 100 pixels will include any border or padding you added, and the content box will shrink to absorb that extra width. This typically makes it much easier to size elements.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> It is often useful to set <code>box-sizing</code> to <code>border-box</code> to layout elements. This makes dealing with the sizes of elements much easier, and generally eliminates a number of pitfalls you can stumble on while laying out your content.  On the other hand, when using <code>position: relative</code> or <code>position: absolute</code>, use of <code>box-sizing: content-box</code> allows the positioning values to be relative to the content, and independent of changes to border and padding sizes, which is sometimes desirable.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>box-sizing</code> property is specified as a single keyword chosen from the list of values below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>content-box</code></dt>
 <dd>This is the initial and default value as specified by the CSS standard. The {{Cssxref("width")}} and {{Cssxref("height")}} properties include the content, but does not include the padding, border, or margin. For example, <code>.box {width: 350px; border: 10px solid black;}</code> renders a box that is 370px wide.</dd>
 <dd>Here, the dimensions of the element are calculated as: <em>width = width of the content</em>, and <em>height = height of the content</em>. (Borders and padding are not included in the calculation.)</dd>
 <dt><code>border-box</code></dt>
 <dd>The {{Cssxref("width")}} and {{Cssxref("height")}} properties include the content, padding, and border, but do not include the margin. Note that padding and border will be inside of the box. For example, <code>.box {width: 350px; border: 10px solid black;}</code> renders a box that is 350px wide, with the area for content being 330px wide. The content box can't be negative and is floored to 0, making it impossible to use <code>border-box</code> to make the element disappear.</dd>
 <dd>Here the dimensions of the element are calculated as: <em>width = border + padding + width of the content</em>, and <em>height = border + padding + height of the content</em>.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Box_sizes_with_content-box_and_border-box">Box sizes with content-box and border-box</h3>

<p>This example shows how different <code>box-sizing</code> values alter the rendered size of two otherwise identical elements.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="content-box"&gt;Content box&lt;/div&gt;
&lt;br&gt;
&lt;div class="border-box"&gt;Border box&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">div {
  width: 160px;
  height: 80px;
  padding: 20px;
  border: 8px solid red;
  background: yellow;
}

.content-box {
  box-sizing: content-box;
  /* Total width: 160px + (2 * 20px) + (2 * 8px) = 216px
     Total height: 80px + (2 * 20px) + (2 * 8px) = 136px
     Content box width: 160px
     Content box height: 80px */
}

.border-box {
  box-sizing: border-box;
  /* Total width: 160px
     Total height: 80px
     Content box width: 160px - (2 * 20px) - (2 * 8px) = 104px
     Content box height: 80px - (2 * 20px) - (2 * 8px) = 24px */
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Box_sizes_with_content-box_and_border-box', 'auto', 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Basic UI', '#box-sizing', 'box-sizing')}}</td>
   <td>{{Spec2('CSS3 Basic UI')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.box-sizing")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Box_Model/Introduction_to_the_CSS_box_model">CSS box model</a></li>
</ul>
